import java.util.*;
import java.text.*;

class Day{
  
  Hour[] hours; //The 12 hours of the opening
  String day; //the created day
  
  Day(String day, ArrayList itemsType){
    hours = new Hour[12]; //hours[0] = 08:00, hours[1] = 09:00 ...etc...hours[11] = 19:00
    this.day = day;
    
    //Create the twelves hour
    hours[0] = new Hour("08:00");
    hours[1] = new Hour("09:00");
    hours[2] = new Hour("10:00");
    hours[3] = new Hour("11:00");
    hours[4] = new Hour("12:00");
    hours[5] = new Hour("13:00");
    hours[6] = new Hour("14:00");
    hours[7] = new Hour("15:00");
    hours[8] = new Hour("16:00");
    hours[9] = new Hour("17:00");
    hours[10] = new Hour("18:00");
    hours[11] = new Hour("19:00");
    
    //loop into all the items type (all the entries)
    for(int i=0; i<itemsType.size(); i++){
      ItemType itemT = (ItemType) itemsType.get(i);
      
      //Check if the item is corresponding to the right day (current displayed day)
      if(day.equals(itemT.outDate)){
        
        //On which hour the item was taken -> update the ItemQuantity of the hour (+ convert the string into GregorianCalendar for comparaison)
        Calendar whichHour = strToDate(itemT.outTime);
        
        //For the 12 hours
        for(int j=0; j<hours.length; j++){
          if(j < hours.length-1){
            
            //Compare the current time of the entry for seeing where is it situated (ex: 13:08 is situated in between 13:00 and 14:00, so it is affected to 13:00)
            int r1 = whichHour.compareTo(hours[j].cal);
            int r2 = whichHour.compareTo(hours[j+1].cal);
            
            if(r1 >= 0 && r2 < 0){
              updateItemQuantity(j, itemT.type);
            }
          }
          //As r2 is J+1...evitate to go out of the array length
          else{
            int r1 = whichHour.compareTo(hours[j].cal);
            
            if(r1 >= 0){
              updateItemQuantity(j, itemT.type);
            }
          }
        }
      }
    }
  }
  
  //Update the quantity of an item
  private void updateItemQuantity(int id, String iType){
    hours[id].updateQuantity(iType);
  }
  
  //Convert String to Date format (for doing comparaison)
  private Calendar strToDate(String h){
    //Init the GregorianCalendar which is a subclass of calendar. this is used in order to
    //make a comparaison with dates.
    Calendar gc = new GregorianCalendar();
    try{
      //Function which convert the date which is a string into a GregorianCalendar
      DateFormat df = new SimpleDateFormat("HH:mm:ss");
      Date d = df.parse(h);
      gc.setTime(d);
    }
    catch(Exception e){
      println("Exception: " + e);
    }
    
    return gc; 
  }
  
}
