import java.util.*;
import java.text.*;

class Hour {

  ArrayList itemsQuantity;
  String h; //Hour in a string type
  Calendar cal; //Hour in a calendar type (for doing comparaison in the Day class)

  Hour(String h) {
    this.h = h;
    itemsQuantity = new ArrayList();

    cal = new GregorianCalendar(); //Init the GregorianCalendar class which is a subclass of the Calendar class.

    try {
      //Convert the hour which is on a string type into a calendar type
      DateFormat df = new SimpleDateFormat("HH:mm");
      Date d = df.parse(h);
      cal.setTime(d);
    }
    catch(Exception e) {
      println("Exception: " + e);
    }
  }

  //Update the quantity of an item of this hour
  void updateQuantity(String type) {
    //for the first entry...create in all case a new itemsquantity
    if(itemsQuantity.size() == 0) {
      ItemsQuantity iq = new ItemsQuantity(type);
      itemsQuantity.add(iq);
    }
    else {
      //loop into all the items quantity for finding if the itemtype already exists.
      boolean found = false;
      for(int i=0; i<itemsQuantity.size(); i++) {
        ItemsQuantity iq = (ItemsQuantity) itemsQuantity.get(i);
        //If the item already exists, his quantity is updated
        if(iq.type.equals(type)) {
          found = true;
          iq.quantity++;
          itemsQuantity.set(i, iq);
          break;
        }
      }
      //If the item is not found, then we create it
      if(!found) {
        ItemsQuantity iq = new ItemsQuantity(type);
        itemsQuantity.add(iq);
      }
    }
  }
  
  //return the quantity of the specified item
  int getQuantityItem(String item){
    for(int i=0; i<itemsQuantity.size(); i++){
      ItemsQuantity iq = (ItemsQuantity) itemsQuantity.get(i);
      if(iq.type.equals(item)){
        return iq.quantity;
      }
    }
    return 0;
  }

  //Sort the items in order to have the books first, then the video vhs, then the audio tapes, then cd, then cd-rom, then dvd.
  //that's why i added an "idType" on the ItemsQuantity class. Make sorting easier.
  void sortItemsType() {
    Collections.sort(itemsQuantity, new Comparator() {

      public int compare(Object o1, Object o2) {
        ItemsQuantity p1 = (ItemsQuantity) o1;
        ItemsQuantity p2 = (ItemsQuantity) o2;
        if(p1.idType >  p2.idType){
          return 1;
        }
        else if(p1.idType < p2.idType){
          return -1;
        }
        else{
          return 0;
        }
      }
    }
    );
  }
}

